Public Class ColorPaletteButton
    'Public enumerations
    Public Enum ButtonAssignments As Integer
        None = 0
        LeftButton = 1
        RightButton = 2
    End Enum

    'Public members
    Public Color As Color = System.Drawing.Color.Black
    Public Rectangle As Rectangle
    Public ButtonAssignment As ButtonAssignments = ButtonAssignments.None

    'Constructor
    Public Sub New(ByVal newColor As Color)
        Color = newColor
    End Sub

    'Move the button to the given position
    Public Sub SetPosition(ByVal x As Integer, ByVal y As Integer, _
                           ByVal buttonSize As Integer)

        'Update the members
        Rectangle = New Rectangle(x, y, buttonSize, buttonSize)
    End Sub

    'Draw the button
    Public Sub Draw(ByVal graphics As Graphics)
        'Draw the color block
        Dim objSolidBrush As New SolidBrush(Color)
        graphics.FillRectangle(objSolidBrush, Rectangle)

        'Draw an edge around the control
        Dim objPen As New Pen(System.Drawing.Color.Black)
        graphics.DrawRectangle(objPen, Rectangle)

        'Are you selected?
        If ButtonAssignment <> ButtonAssignments.None Then

            'Create a font
            Dim objFont As New Font("verdana", 8, FontStyle.Bold)

            'Set the default button assignment
            Dim strButtonText As String = "L"

            'Update the button assignment if necessary
            If ButtonAssignment = ButtonAssignments.RightButton Then
                strButtonText = "R"
            End If

            'What brush do you want?
            If Color.R < 100 Or Color.B < 100 Or Color.G < 100 Then
                objSolidBrush = New SolidBrush(System.Drawing.Color.White)
            Else
                objSolidBrush = New SolidBrush(System.Drawing.Color.Black)
            End If

            'Draw the text 'L' or 'R'
            graphics.DrawString(strButtonText, objFont, objSolidBrush, _
                  Rectangle.Left, Rectangle.Top)
        End If
    End Sub

End Class
